<?php
class ControllerExtensionPaymentPas extends Controller {
	public function index() {
		$this->language->load('extension/payment/pas');
    	$data['button_confirm'] = $this->language->get('button_confirm');

		$data['text_loading'] = $this->language->get('text_loading');
		$this->load->model('checkout/order');
		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
		
		$data['order_id'] = $this->session->data['order_id'];
		$data['back'] = $this->url->link('checkout/payment', '', true);
		$amount = $this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false);
		$amount = round($amount);
		$amount = $this->currency->convert($amount, $order_info['currency_code'], "RLS");
			
        $data['order_id'] = $this->session->data['order_id'];
		$amount = trim($amount);
		$invoiceNumber = time();

		$terminal = trim($this->config->get('payment_pas_terminal'));
		$redirectAddress  =  ($this->url->link('extension/payment/pas/callback','', true));
		$payload=array('cms'=>'OpenCart','cms_ver'=>'3.0');
		$payload=json_encode($payload);
		$params ='terminalID='.$terminal.'&Amount='.$amount.'&callbackURL='.urlencode($redirectAddress).'&invoiceID='.$invoiceNumber.'&Payload='.urlencode($payload);
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, 'https://sepehr.shaparak.ir:8081/V1/PeymentApi/GetToken');
		curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		$res = curl_exec($ch);
		curl_close($ch);
		if($res)
		{
			$res = json_decode($res,true);
			if($res['Status'] == '0')
			{	  
				$data['action'] = "https://sepehr.shaparak.ir:8080";
				
				$data['TerminalID']=$terminal;
				$data['token']=$res['Accesstoken'];
				return $this->load->view('extension/payment/pas', $data);
			}else
			{
				$data['errors']=('خطا در ساخت توکن <br/> کد خطا :'.$res['Status']);
				return $this->load->view('extension/payment/pas', $data);
			}
		}
		else
		{
			$data['errors']=('پورت 8081 در هاست شما بسته است !');
			return $this->load->view('extension/payment/pas', $data);
		}
	}

	public function callback() 
	{
		$this->language->load('extension/payment/pas');
		@session_start();

		$order_id = isset($this->session->data['order_id']) ? $this->session->data['order_id'] : 0;
		$_POST['digitalreceipt'] = $this->db->escape($this->request->post["digitalreceipt"]);
		
		if ($_SERVER["REQUEST_METHOD"] != "POST") 
		{
			$_POST +=$_GET;
			$_POST['digitalreceipt'] = $this->db->escape($this->request->get["digitalreceipt"]);
		}
		$this->document->setTitle('برگشت از درگاه');
		$data['text_wait'] = $this->language->get('text_wait');
		$data['text_heading'] = $this->language->get('text_heading');
		$data['text_results'] = $this->language->get('text_results');
		$data['button_confirm'] = $this->language->get('button_confirm');
		$data['button_continue'] = $this->language->get('button_continue');
		$data['breadcrumbs'] = array();
		$data['breadcrumbs'][] = array('text' => $this->language->get('text_home'), 'href' => $this->url->link('common/home', '', 'SSL'), 'separator' => false);
		$data['breadcrumbs'][] = array('text' => 'پرداخت', 'href' => $this->url->link('payment/pas/callback', '', 'SSL'), 'separator' => $this->language->get('text_separator'));
		$data['error_warning'] = '';

		if( isset($_POST['respcode']) && $_POST['respcode'] == '0' )
		{

			$terminal = trim($this->config->get('payment_pas_terminal'));
			
			$this->load->model('checkout/order');
			$order_info = $this->model_checkout_order->getOrder($order_id);
			
			$amount = $this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false);
			$amount = round($amount);
			$amount = $this->currency->convert($amount, $order_info['currency_code'], "RLS");
	
			if ($order_info) 
			{

				$order_history = $this->db->query("SELECT count(*) as cc FROM " . DB_PREFIX . "order_history WHERE comment = '" .$_POST['digitalreceipt']. "'");
				if ($order_history->num_rows && $order_history->row['cc'] == 0) 
				{
					$params ='digitalreceipt='.$_POST['digitalreceipt'].'&Tid='.$terminal;
					$ch = curl_init();
					curl_setopt($ch, CURLOPT_URL, 'https://sepehr.shaparak.ir:8081/V1/PeymentApi/Advice');
					curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
					curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
					curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
					$res = curl_exec($ch);
					curl_close($ch);
					$result = json_decode($res,true);
					 if (strtoupper($result['Status']) == 'OK') 
					 {
						
						if(floatval($result['ReturnId'])  == floatval($amount))
						{
							$referenceId = $_POST['digitalreceipt'];
							$data['authority'] = $referenceId;
							$data['continue'] = $this->url->link('checkout/success');
							$this->model_checkout_order->addOrderHistory($order_id, $this->config->get('payment_pas_order_status_id'),$referenceId, true);
							$data['error_warning'] = NULL;
							$location = ($this->url->link('checkout/success', '', 'SSL'));
							
							if (!headers_sent()) {
								header('Location: ' . $location);
							  } else
							  {
								  echo '<script type="text/javascript">';
								  echo 'window.location.href="' . $location . '";';
								  echo '</script>';
							  }

						}
						else
						{
							$data['error_warning'] = 'مبلغ واریز با قیمت محصول برابر نیست ، مبلغ واریزی :'.$result['ReturnId'];
							$data['continue'] = $this->url->link('checkout/checkout');
						}
						
					}
					else 
					{
						switch($result['ReturnId'])
						{
							case '-1' : $res = 'تراکنش پیدا نشد';break;
							case '-2' : $res = 'تراکنش قبلا Reverse شده است';break;
							case '-3' : $res = 'خطا عمومی';break;
							case '-4' : $res = 'امکان انجام درخواست برای این تراکنش وجود ندارد';break;
							case '-5' : $res = 'آدرس IP پذیرنده نامعتبر است';break;
							default  : $res = 'خطای ناشناس : '.$result['ReturnId'];break;
							
						}
						$data['error_warning'] = $res;
						$data['continue'] = $this->url->link('checkout/checkout');
					}
				}
				else 
				{
					$data['error_warning'] ='رسید دیجیتال قبلا استفاده شده است';
					$data['continue'] = $this->url->link('checkout/checkout');
				}
			}	
			else 
			{
				$data['error_warning'] ='سفارش یافت نشد';
				$data['continue'] = $this->url->link('checkout/checkout');
			}			
		}
		else 
		{
			$data['heading_title'] = 'خطا';
			$data['error_warning'] = 'تراکش توسط کاربر کنسل شد';
			$data['continue'] = $this->url->link('checkout/checkout');
		}
		
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['column_right'] = $this->load->controller('common/column_right');
		$data['content_top'] = $this->load->controller('common/content_top');
		$data['content_bottom'] = $this->load->controller('common/content_bottom');
		$data['footer'] = $this->load->controller('common/footer');
		$data['header'] = $this->load->controller('common/header');
		

		$this->response->setOutput($this->load->view('extension/payment/pas_confirm', $data));
		
	

	}
}
?>